﻿	' Set up SettingsClosing event
	Dim objFSO, objRegExp, objShell
	
	Sub Window_OnLoad
		' These objects will be used fairly frequently
		Set objFSO = CreateObject("Scripting.FileSystemObject")
		Set objShell = CreateObject("WScript.Shell")
		Set objRegExp = New RegExp
		objRegExp.Pattern = ".png$|.jpg$|.gif$"
		objRegExp.Ignorecase = True
		
		' Get Lists of images in folders
		Call PopulateSelect("GBGSelect")
		Call PopulateSelect("BarBGSelect")
		Call PopulateSelect("BarFGSelect")
		' Initialize to show current info
		Call InitializeComponent("GBGSelect")
		Call InitializeComponent("BarBGSelect")
		Call InitializeComponent("BarFGSelect")
		' More initialization
		colVal = System.Gadget.Settings.readString("TextColor")
		sampleText.style.color = colVal
		Set objColorBox = document.getElementById("textColorBox")
		objColorBox.value = colVal
		' Intercept these events to allow drop files to work
		document.body.ondragenter = GetRef("InterceptDragEnter")
		document.body.ondragover = GetRef("InterceptDragOver")
	End Sub
	' This really should work, but does not, so I use javascript for this
	'System.Gadget.onSettingsClosing = GetRef("SettingsClosing")
	
	Sub InterceptDragEnter
		window.event.returnValue = false
	End Sub
	Sub InterceptDragOver
		window.event.returnValue = false
	End Sub
	
	Sub OpenFolder(selectID)
		Select Case selectID
			Case "GBGSelect"
				strFolder = System.Gadget.path & "\assets\Gadget_Backgrounds\"
			Case "BarBGSelect"
				strFolder = System.Gadget.path & "\assets\Bar_Backgrounds\"
			Case "BarFGSelect"
				strFolder = System.Gadget.path & "\assets\Bar_Foregrounds\"
			Case Else
				strFolder = "False"
		End Select
		objShell.Run Chr(34) & strFolder & Chr(34)
	End Sub

	Function ProcessDrop(selectID)
		'MsgBox "Drop! " & window.event.type
		' Get the first (and usually only) path of the files dropped
		pathInfo = System.Shell.itemFromFileDrop(window.event.dataTransfer, 0).path
		'pathInfo = objFSO.GetAbsolutePathName(pathInfo)
		If objRegExp.Test(pathInfo) = False Then
			MsgBox pathInfo & vbNewLine & "Does not appear to be an image."
			Exit Function
		End If
		Select Case selectID
			Case "GBGSelect"
				strFolder = System.Gadget.path & "\assets\Gadget_Backgrounds\"
			Case "BarBGSelect"
				strFolder = System.Gadget.path & "\assets\Bar_Backgrounds\"
			Case "BarFGSelect"
				strFolder = System.Gadget.path & "\assets\Bar_Foregrounds\"
			Case Else
				strFolder = "False"
		End Select
		Dim ind
		ind = -1
		objFSO.CopyFile pathInfo, strFolder
		
		Call PopulateSelect(selectID)
		Set objSelect = document.getElementById(selectID)
		'MsgBox pathInfo & vbNewLine & strFolder & vbNewLine & "Items: " & objSelect.length & objSelect(0).value
		'MsgBox Chr(34) & pathInfo & Chr(34)
		For i = 0 to objSelect.length
			If objSelect(i).value = (strFolder & objFSO.GetFileName(pathInfo)) Then
				objSelect.selectedIndex = i
				Exit For
			End If
		Next
		Call SelectionChange(selectID)
		'MsgBox objSelect(0).text
		'MsgBox pathInfo
	End Function

	
	Function PopulateSelect(selectID)
		Dim objSelect, arrImages
		
		arrImages = GetComponentImages(selectID)
		Set objSelect = document.getElementById(selectID)
		objSelect.length = 0
		For Each imgPath in arrImages
		'For i = 0 to UBound(arrImages)
			Set newElem = document.createElement("Option")
			newElem.text = objFSO.GetFileName(imgPath)
			'newElem.text = imgPath
			newElem.value = imgPath
			objSelect.add newElem
		Next
		Set objSelect = Nothing
	End Function
	
	Function InitializeComponent(selectID)
		'MsgBox "Initialize: " & selectID
		Dim objSelect, objImgElem
		Set objSelect = document.getElementById(selectID)
		Select Case selectID
			Case "GBGSelect"
				strSetting = "GadgetBackground"
				Set objImgElem = document.getElementById("sampleGadgetBG")
			Case "BarBGSelect"
				strSetting = "BarBackground"
				Set objImgElem = document.getElementById("sampleBarBG")
			Case "BarFGSelect"
				strSetting = "BarForeground"
				Set objImgElem = document.getElementById("sampleBarFG")
			Case Else
				InitializeComponent = "False"
		End Select
		currentImagePath = System.Gadget.Settings.readString(strSetting)
		objImgElem.src = currentImagePath
		For i = 0 to objSelect.length
			objSelect.selectedIndex = i
			If objSelect.value = currentImagePath Then
				Exit For
			End If
		Next

	End Function
	
	Function GetComponentImages(selectID)
		Dim strFolder
		Dim gadgetsFolderPath
		'gadgetsFolderPath = objShell.ExpandEnvironmentStrings("%userprofile%\AppData\Local\Microsoft\Windows Sidebar\Gadgets\")
		'gadgetsFolderPath = System.Shell.knownFolderPath("GadgetsUser")
		Select Case selectID
			Case "GBGSelect"
				strFolder = System.Gadget.path & "\assets\Gadget_Backgrounds\"
			Case "BarBGSelect"
				strFolder = System.Gadget.path & "\assets\Bar_Backgrounds\"
			Case "BarFGSelect"
				strFolder = System.Gadget.path & "\assets\Bar_Foregrounds\"
			Case Else
				strFolder = "False"
		End Select
		If objFSO.FolderExists(strFolder) = False Then
			MsgBox "Folder Path Error"
			GetComponentImages = False
			Exit Function
		End If
		Dim objFolder, arrImageFiles(), fileCount
		fileCount = 0
		Set objFolder = objFSO.GetFolder(strFolder)
		Set colFiles = objFolder.Files
		msg = "Files in Folder " & objFolder.Name
		For Each objFile in colFiles
			If objRegExp.Test(objFile.Path) = True Then
				'MsgBox objFile.Path
				ReDim Preserve arrImageFiles(fileCount)
				arrImageFiles(fileCount) = objFile.Path
				msg = msg & vbNewLine & objFile.Path
				fileCount = fileCount + 1
			End If
    		'Wscript.Echo objFile.Name
		Next
		'MsgBox msg
		GetComponentImages = arrImageFiles
		Set colFiles = Nothing
		'Set arrImageFiles = Nothing
		Set objFolder = Nothing
	End Function
	
	Function SelectionChange(selectID)
		'MsgBox "Selection made on: " & selectID
		Dim objSelect
		Set objSelect = document.getElementById(selectID)
		Select Case selectID
			Case "GBGSelect"
				sampleGadgetBG.src = objSelect.value
			Case "BarBGSelect"
				sampleBarBG.src = objSelect.value
			Case "BarFGSelect"
				sampleBarFG.src = objSelect.value
			Case Else
				SelectionChange = "False"
		End Select
		Set objSelect = Nothing
	End Function
	
	Function ButtonClickPrevious(selectID)
		Set objSelect = document.getElementById(selectID)
		curIndex = objSelect.selectedIndex
		If curIndex > 0 Then
			objSelect.selectedIndex = curIndex - 1
		Else
			objSelect.selectedIndex = objSelect.length - 1
		End If
		Call SelectionChange(selectID)
		Set objSelect = Nothing
	End Function
	
	Function ButtonClickNext(selectID)
		Set objSelect = document.getElementById(selectID)
		curIndex = objSelect.selectedIndex
		If curIndex < (objSelect.length - 1) Then
			objSelect.selectedIndex = curIndex + 1
		Else
			objSelect.selectedIndex = 0
		End If
		Call SelectionChange(selectID)
		Set objSelect = Nothing
	End Function

	Sub Window_OnUnload
		'MsgBox "Uloaded settings"
		
		Set objFSO = Nothing
		Set objRegExp = Nothing
		Set objShell = Nothing
	End Sub